<?php
/***********************************************************
*  Various helping functions for the Input area of modules *
*  Author:  B. Behrens, HerrB                              *
*  Version: 1.3                                            *
************************************************************/

function fncBuildCategorySelect($sName, $sSelCat, $sLevel = 0, $sOnChange = '', $sSize = '1', $sType = '', $bWithArticle = false, $sSelCatArt = "0", $sDisabled = '') {
   global $cfg, $client, $lang, $idcat;

   $db  = new DB_Contenido;
   $db2 = new DB_Contenido;

   if ($sType) {
      $sType = " multiple";
   }
   if (!is_numeric($sSize)) {
      $sSize = "1";
   }
   $aSelCat    = explode(",", $sSelCat);
   $aSelCatArt = explode(",", $sSelCatArt);

   $sql  = "SELECT a.idcat AS idcat, b.name AS name, b.visible AS visible, b.public AS public, c.level AS level FROM ".
           $cfg["tab"]["cat"]." AS a, ".$cfg["tab"]["cat_lang"]." AS b, ".$cfg["tab"]["cat_tree"]." AS c ".
           "WHERE a.idclient = '".$client."' AND b.idlang = '".$lang."' AND b.idcat = a.idcat AND c.idcat = a.idcat ";
   if ($sLevel > 0) {
      $sql .= "AND c.level < '".$sLevel."' ";
   }
   $sql .= "ORDER BY c.idtree";

   $db->query($sql);

   if ($db->num_rows() == 0 || $sDisabled) {
      $sDisabled = ' disabled="disabled"';
   } else {
      $sDisabled = '';
   }

   $sHtml  = '<select name="'.$sName.'"'.$sType.' size="'.$sSize.'" onchange="'.$sOnChange.'"'.$sDisabled.'>'."\n";
   $sHtml .= '  <option value="">'.i18n("Please choose").'</option>'."\n";

   while ($db->next_record()) {
      $sSpaces = "&nbsp;&nbsp;";

      for ($i = 0; $i < $db->f("level"); $i ++) {
         $sSpaces .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
      }

      $sSelected = "";
      if (in_array($db->f("idcat"), $aSelCat)) {
         $sSelected = ' selected="selected"';
      }
      $sStyle = "";
      if ($db->f("visible") == 0 || $db->f("public") == 0) {
         $sStyle = 'color: #666666;';
      }

      $sHtml .= '<option value="'.$db->f("idcat").'" style="background-color:#EFEFEF;'.$sStyle.'"'.$sSelected.'>'.$sSpaces.">".urldecode($db->f("name")).'</option>'."\n";

      if ($bWithArticles) {
         $sql2 = "SELECT a.title AS title, b.idcatart AS idcatart, a.online AS online FROM
                 ".$cfg["tab"]["art_lang"]." AS a,  ".$cfg["tab"]["cat_art"]." AS b
                 WHERE b.idcat = '".$db->f("idcat")."' AND a.idart = b.idart AND
                 a.idlang = '".$lang."' ORDER BY a.title";
         $db2->query($sql2);

         while ($db2->next_record()) {
            $sSelected = "";
            if (in_array($db2->f("idcatart"), $aSelCatArt)) {
               $sSelected = ' selected="selected"';
            }
            $sStyle = "";
            if ($db2->f("online") == 0) {
               $sStyle = 'color: #666666;';
            }
            $sHtml .= '<option value="'.$db2->f("idcatart").'" style="background-color:#EFEFEF;'.$sStyle.'"'.$sSelected.'>'.$sSpaces.
                      '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.substr(urldecode($db2->f("title")), 0, 32).'</option>'."\n";
         }
      }
   }

   $sHtml .= '</select>'."\n";

   unset ($db2);
   unset ($sql);
   unset ($aCategories);
   unset ($sSpaces);
   unset ($sSelected);
   unset ($sStyle);

   return $sHtml;
}

function fncBuildArticleSelect($sName, $sIDCat, $sSelCatArt, $sOnChange = '', $sDisabled = '') {
   global $cfg, $lang;

   $db2 = new DB_Contenido;

   if (is_numeric($sIDCat) && $sIDCat > 0) {
      $sql  = "SELECT a.title AS title, b.idcatart AS idcatart, a.online AS online ";
      $sql .= "FROM ".$cfg["tab"]["art_lang"]." AS a, ".$cfg["tab"]["cat_art"]." AS b ";
      $sql .= "WHERE a.online = '1' AND b.idcat = '".$sIDCat."' AND a.idart = b.idart AND a.idlang = '".$lang."'";

      $db2->query($sql);

      if ($db2->num_rows() == 0 || $sDisabled) {
         $sDisabled = ' disabled="disabled"';
      } else {
         $sDisabled = '';
      }

      $sHtml  = '<select name="'.$sName.'" onchange="'.$sOnChange.'"'.$sDisabled.'>'."\n";
      $sHtml .= '   <option value="" selected>'.i18n("Please choose").'</option>'."\n";

      while ($db2->next_record()) {
         $sSelected = "";
         if ($sSelCatArt == $db2->f("idcatart")) {
            $sSelected = ' selected="selected"';
         }
         $sStyle = "";
         if ($db2->f("online") == 0) {
            $sStyle = 'color: #666666;';
         }

         $sHtml .= '<option value="'.$db2->f("idcatart").'" style="'.$sStyle.'"'.$sSelected.'>&nbsp;'.substr(urldecode($db2->f('title')), 0, 32).'</option>'."\n";
      }
   } else {
      $sHtml  = '<select name="'.$sName.'" disabled="disabled">'."\n";
      $sHtml .= '   <option value="" selected>'.i18n("Please choose").'</option>'."\n";
   }
   $sHtml .= '</select>'."\n";

   unset ($db2);
   unset ($sSelected);
   unset ($sStyle);

   return $sHtml;
}

function fncBuildTypeSelect($sName, $lIDCatArt, $sValue, $sTypeRange = '', $sOnChange = '', $sDisabled = '') {
   global $cfg, $lang;

   $db2 = new DB_Contenido;

   if (is_numeric($lIDCatArt) && $lIDCatArt > 0) {
      $sql = "SELECT
           a.typeid AS typeid,
           a.value AS value,
           a.idtype AS idtype,
           d.type AS type,
           d.description AS description
              FROM
           ".$cfg["tab"]["content"]." AS a,
           ".$cfg["tab"]["art_lang"]." AS b,
           ".$cfg["tab"]["cat_art"]." AS c,
           ".$cfg["tab"]["type"]." AS d
              WHERE
           a.idtype    = d.idtype AND
           a.idartlang = b.idartlang AND
           b.idart     = c.idart AND
           b.idlang    = '".$lang."' AND ";
      if ($sTypeRange != "") {
         $sql .= "a.idtype IN (".$sTypeRange.") AND ";
      }
      $sql .= "     c.idcatart = '".$lIDCatArt."'
              ORDER BY a.idtype, a.typeid";

      $db2->query($sql);

      if ($db2->num_rows() == 0 || $sDisabled) {
         $sDisabled = ' disabled="disabled"';
      } else {
         $sDisabled = '';
      }

      $html  = '<select name="'.$sName.'" onchange="'.$sOnChange.'"'.$sDisabled.'>'."\n";
      $html .= '   <option value="" selected>'.i18n("Please choose").'</option>'."\n";

      while ($db2->next_record()) {
         $sTypeIdentifier = "tblData.idtype = '".$db2->f('idtype')."' AND tblData.typeid = '".$db2->f('typeid')."'";
         $sContent = $db2->f('type')."[".$db2->f('typeid')."]: ".substr(strip_tags(urldecode($db2->f("value"))), 0, 50);
         $sDescription = i18n($db2->f("description"));

         if ($sValue != $sTypeIdentifier) {
            $html .= '<option value="'.$sTypeIdentifier.'">&nbsp;'.$sContent.'</option>'."\n";
         } else {
            $html .= '<option selected="selected" value="'.$sTypeIdentifier.'">&nbsp;'.$sContent.'</option>'."\n";
         }
      }
   } else {
      $html  = '<select name="'.$sName.'" disabled="disabled">'."\n";
      $html .= '   <option value="" selected>'.i18n("Please choose").'</option>'."\n";
   }
   $html .= '</select>'."\n";

   unset ($db2);
   unset ($sTypeIdentifier);
   unset ($sContent);
   unset ($sDescription);

   return $html;
}

function fncAddMultiSelJS () {
   // Trick: To save multiple selections in <select>-Element, add some JS which saves the
   // selection, comma separated in a hidden input field on change.
   // Note tha hard-coded forms name "tplcfgform"
   $sHTML  = '<script type="text/javascript"><!--'."\n";
   $sHTML .= '                  function ArtAdv_fncUpdateSel(sListBox, sField) {'."\n";
   $sHTML .= '                     var sSel = "";'."\n";
   $sHTML .= '                     for (i = 0; i < document.tplcfgform.elements[sListBox].length; i++) {'."\n";
   $sHTML .= '                        if (document.tplcfgform.elements[sListBox].options[i].selected == true) {'."\n";
   $sHTML .= '                           if (sSel != "") {'."\n";
   $sHTML .= '                              sSel = sSel + ",";'."\n";
   $sHTML .= '                           }'."\n";
   $sHTML .= '                           sSel = sSel + document.tplcfgform.elements[sListBox].options[i].value;'."\n";
   $sHTML .= '                        }'."\n";
   $sHTML .= '                     }'."\n";
   $sHTML .= '                     document.tplcfgform.elements[sField].value = sSel;'."\n";
   $sHTML .= '                  }'."\n";
   $sHTML .= '                  //--></script>'."\n";
   return $sHTML;
}
?>